<html>
<head>
<title>OgreGLGpuProgram.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_5bc5f2f46c6364f2594540d45df3d051.html">GL</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7b8a29f58b064e3a63f570f2fc89729.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLGpuProgram.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLGpuProgram_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __GLGpuProgram_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __GLGpuProgram_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLPrerequisites_8h.html">OgreGLPrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreGpuProgram_8h.html">OgreGpuProgram.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareVertexBuffer_8h.html">OgreHardwareVertexBuffer.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00037"></a>00037 
<a name="l00039"></a><a class="code" href="classOgre_1_1GLGpuProgram.html">00039</a>     <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLGpuProgram.html" title="Generalised low-level GL program, can be applied to multiple types (eg ARB and NV)">GLGpuProgram</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program.">GpuProgram</a>
<a name="l00040"></a>00040     {
<a name="l00041"></a>00041     <span class="keyword">public</span>:
<a name="l00042"></a>00042         <a class="code" href="classOgre_1_1GLGpuProgram.html" title="Generalised low-level GL program, can be applied to multiple types (eg ARB and NV)">GLGpuProgram</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00043"></a>00043             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual = <span class="keyword">false</span>, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader = 0);
<a name="l00044"></a>00044         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1GLGpuProgram.html" title="Generalised low-level GL program, can be applied to multiple types (eg ARB and NV)">GLGpuProgram</a>();
<a name="l00045"></a>00045 
<a name="l00047"></a><a class="code" href="classOgre_1_1GLGpuProgram.html#a5913d9b5618d00b55a976dcae972976e">00047</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLGpuProgram.html#a5913d9b5618d00b55a976dcae972976e" title="Execute the binding functions for this program.">bindProgram</a>(<span class="keywordtype">void</span>) {}
<a name="l00049"></a><a class="code" href="classOgre_1_1GLGpuProgram.html#ae26414aa1f1cb664428d76a73d4ef6b1">00049</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLGpuProgram.html#ae26414aa1f1cb664428d76a73d4ef6b1" title="Execute the binding functions for this program.">unbindProgram</a>(<span class="keywordtype">void</span>) {}
<a name="l00050"></a>00050 
<a name="l00052"></a><a class="code" href="classOgre_1_1GLGpuProgram.html#a1f350ae20d37d7ed7aa97dd9de924e79">00052</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLGpuProgram.html#a1f350ae20d37d7ed7aa97dd9de924e79" title="Execute the param binding functions for this program.">bindProgramParameters</a>(<a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> params, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> mask) {}
<a name="l00054"></a><a class="code" href="classOgre_1_1GLGpuProgram.html#a21b34c495eab6f5544ba15017d96c5ad">00054</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLGpuProgram.html#a21b34c495eab6f5544ba15017d96c5ad" title="Bind just the pass iteration parameters.">bindProgramPassIterationParameters</a>(<a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> params) {}
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00058"></a><a class="code" href="classOgre_1_1GLGpuProgram.html#a1cfa639a82beb5c16b4373440cacdff9">00058</a>         GLuint getProgramID(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00059"></a>00059 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mProgramID; }
<a name="l00060"></a>00060 
<a name="l00066"></a>00066         <span class="keyword">virtual</span> GLuint getAttributeIndex(<a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> semantic, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> index);
<a name="l00069"></a>00069         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isAttributeValid(<a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> semantic, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> index);
<a name="l00070"></a>00070 
<a name="l00072"></a>00072         <span class="keyword">static</span> GLuint getFixedAttributeIndex(<a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> semantic, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> index);
<a name="l00073"></a>00073 
<a name="l00074"></a>00074     <span class="keyword">protected</span>:
<a name="l00076"></a><a class="code" href="classOgre_1_1GLGpuProgram.html#a93f7cda9e1fa2e7067a75f6a8139ea66">00076</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLGpuProgram.html#a93f7cda9e1fa2e7067a75f6a8139ea66" title="Overridden from GpuProgram, do nothing.">loadFromSource</a>(<span class="keywordtype">void</span>) {}
<a name="l00078"></a><a class="code" href="classOgre_1_1GLGpuProgram.html#af753435392c252563252a9d3ffa8b139">00078</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLGpuProgram.html#af753435392c252563252a9d3ffa8b139">unloadImpl</a>(<span class="keywordtype">void</span>) {}
<a name="l00079"></a>00079 
<a name="l00080"></a><a class="code" href="classOgre_1_1GLGpuProgram.html#a6519ec96ce762b2fec351d4b7a360899">00080</a>         GLuint <a class="code" href="classOgre_1_1GLGpuProgram.html#a6519ec96ce762b2fec351d4b7a360899">mProgramID</a>;
<a name="l00081"></a><a class="code" href="classOgre_1_1GLGpuProgram.html#a1253b7ea61fd8d6a840a8b021bcceace">00081</a>         GLenum <a class="code" href="classOgre_1_1GLGpuProgram.html#a1253b7ea61fd8d6a840a8b021bcceace">mProgramType</a>;
<a name="l00082"></a>00082     };
<a name="l00083"></a>00083 
<a name="l00085"></a><a class="code" href="classOgre_1_1GLArbGpuProgram.html">00085</a>     <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLArbGpuProgram.html" title="Specialisation of the GL low-level program for ARB programs.">GLArbGpuProgram</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1GLGpuProgram.html" title="Generalised low-level GL program, can be applied to multiple types (eg ARB and NV)">GLGpuProgram</a>
<a name="l00086"></a>00086     {
<a name="l00087"></a>00087     <span class="keyword">public</span>:
<a name="l00088"></a>00088         <a class="code" href="classOgre_1_1GLArbGpuProgram.html" title="Specialisation of the GL low-level program for ARB programs.">GLArbGpuProgram</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00089"></a>00089             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual = <span class="keyword">false</span>, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader = 0);
<a name="l00090"></a>00090         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1GLArbGpuProgram.html" title="Specialisation of the GL low-level program for ARB programs.">GLArbGpuProgram</a>();
<a name="l00091"></a>00091 
<a name="l00093"></a>00093         <span class="keywordtype">void</span> setType(<a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> t);
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00097"></a>00097         <span class="keywordtype">void</span> bindProgram(<span class="keywordtype">void</span>);
<a name="l00099"></a>00099         <span class="keywordtype">void</span> unbindProgram(<span class="keywordtype">void</span>);
<a name="l00101"></a>00101         <span class="keywordtype">void</span> bindProgramParameters(<a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> params, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> mask);
<a name="l00103"></a>00103         <span class="keywordtype">void</span> bindProgramPassIterationParameters(<a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> params);
<a name="l00104"></a>00104 
<a name="l00106"></a><a class="code" href="classOgre_1_1GLArbGpuProgram.html#adc42473906050036cbbf774e803f4d90">00106</a>         GLuint getProgramType(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00107"></a>00107 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mProgramType; }
<a name="l00108"></a>00108 
<a name="l00109"></a>00109     <span class="keyword">protected</span>:
<a name="l00110"></a>00110         <span class="keywordtype">void</span> loadFromSource(<span class="keywordtype">void</span>);
<a name="l00112"></a>00112         <span class="keywordtype">void</span> unloadImpl(<span class="keywordtype">void</span>);
<a name="l00113"></a>00113 
<a name="l00114"></a>00114     };
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 } <span class="comment">// namespace Ogre</span>
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 <span class="preprocessor">#endif // __GLGpuProgram_H__</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
